import { jsx as _jsx } from "react/jsx-runtime";
import { useEffect, useRef, useState } from 'react';
import { usePrefixConfig } from '../root';
export function DNumber(props) {
    const { dValue, dDown } = props;
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const containerRef = useRef(null);
    //#endregion
    const dataRef = useRef({
        prevValue: dValue,
    });
    const [nums, setNums] = useState([dValue]);
    useEffect(() => {
        if (containerRef.current && dataRef.current.prevValue !== dValue) {
            let newNums = Array.from({ length: 10 }).map((_, i) => i);
            if (dDown) {
                newNums = newNums.concat(Array.from({ length: dataRef.current.prevValue + 1 }).map((_, i) => i));
                newNums = newNums.slice(newNums.length - 10, newNums.length);
                containerRef.current.style.cssText = 'transform:translateY(-900%);transition:none;';
            }
            else {
                newNums = Array.from({ length: 10 - dataRef.current.prevValue })
                    .map((_, i) => dataRef.current.prevValue + i)
                    .concat(newNums);
                newNums = newNums.slice(0, 10);
                containerRef.current.style.cssText = 'transform:translateY(0);transition:none;';
            }
            dataRef.current.prevValue = dValue;
            setNums(newNums);
        }
    }, [dDown, dValue]);
    useEffect(() => {
        if (containerRef.current) {
            containerRef.current.style.cssText = `transform:translateY(-${nums.findIndex((n) => n === dValue) * 100}%); `;
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [nums]);
    return (_jsx("div", Object.assign({ ref: containerRef, className: `${dPrefix}badge__number-container` }, { children: nums.map((n, i) => (_jsx("span", Object.assign({ className: `${dPrefix}badge__number` }, { children: n }), i))) })));
}
