var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { LoadingOutlined, PlusOutlined } from '@react-devui/icons';
import { getClassName } from '@react-devui/utils';
import { registerComponentMate } from '../../utils';
import { useComponentConfig, usePrefixConfig } from '../root';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DFab.Button' });
function FabButton(props, ref) {
    var _a;
    const _b = useComponentConfig(COMPONENT_NAME, props), { children, dType = 'primary', dTheme = 'primary', dLoading = false, dVariant } = _b, restProps = __rest(_b, ["children", "dType", "dTheme", "dLoading", "dVariant"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const disabled = restProps.disabled || dLoading;
    return (_jsxs("button", Object.assign({}, restProps, { ref: ref, className: getClassName(restProps.className, `${dPrefix}fab__button`, `${dPrefix}fab__button--${dType}`, `t-${dTheme}`, {
            [`${dPrefix}fab__button--${dVariant}`]: dVariant,
            'is-loading': dLoading,
        }), type: (_a = restProps.type) !== null && _a !== void 0 ? _a : 'button', disabled: disabled }, { children: [_jsx(PlusOutlined, { className: `${dPrefix}fab__close-icon` }), _jsx("div", Object.assign({ className: `${dPrefix}fab__button-content` }, { children: dLoading ? _jsx(LoadingOutlined, { dSpin: true }) : children }))] })));
}
export const DFabButton = React.forwardRef(FabButton);
